describe('getweatherdatatest', function() {
  var weatherHandler;
  var domElements;
  var document;
  
  beforeEach(function() {
    weatherHandler = new WeatherHandler();

    domElements = {
      lat: { value: 32 },
      lon: { value: 44 },
      temperature: { innerHTML: ''},
      condition: { innerHTML: ''},
      submit: {}
    }
    document = {
      getElementById: function(id) {  return domElements[id]; }
    }
  });
  
  it('canary', function() {
    expect(true).to.be.eql(true);
  });

  it('getWeatherData sends request to right URL', function() {
    var theURL;
    
    $.get = function(url) {
      theURL = url;
    }
    
    weatherHandler.getWeatherData(document);
    expect(theURL).to.be.eql('/weather?lat=32&lon=44');
  });
  
  it('getWeatherData invokes updateWeather on success', function() {
    var called;
    var sampleData = "OK";

    weatherHandler.updateWeather = function(theDocument, theData) {
      expect(theDocument).to.be.eql(document);
      expect(theData).to.be.eql(sampleData);
      called = true;
    }
    
    $.get = function(url, success) {
      success(sampleData);
    }
    
    weatherHandler.getWeatherData(document);
    expect(called).to.be.eql(true);
  });
  
  it('updateWeather updates the proper dom elements', function() {
    var weatherData = {temperature: 12, condition: 'nice'};
    
    weatherHandler.updateWeather(document, weatherData);
    expect(domElements.temperature.innerHTML).to.be.eql(12);
    expect(domElements.condition.innerHTML).to.be.eql("nice");
  });
  
  it('register click event for submit button', function() {
    var weatherHandler = registerEvents(document);

    var called;
    weatherHandler.getWeatherData = function(theDocument) {
      expect(theDocument).to.be.eql(document);
      called = true;
    }
    
    domElements.submit.onclick(document);
    expect(called).to.be.eql(true);
  });  
});